#!/bin/bash
# Job => 
# -init -- do commands before execution and compilation
# ./C.sh init <idbox>
# -compile -- do all necessary operation for succesfull compilation
# ./C.sh compile
# -run -- will run tested program
# ./C.sh run <idbox> <timeout> "userArg1 userArg2"
# -clean -- do command to clear some txt files or whatever else
# ./C.sh clean
# -remove <idbox> -- will remove compiled program and created txt´s
# ./C.sh remove boxid
Job=$1
IDBOX=$2
CompErrFile=CompErr.log
RunErrFile=RunErr.log
MetaFile=MetaFile.log
OutputBuffer=OutBuffer.log
Input=XX_data_prog_input_XX.txt
Piskot_Dir="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
Test_Dir=$(pwd)


case $Job in
init)
isolate --box-id=$IDBOX --cleanup 
isolate --box-id=$IDBOX --init


;;
compile)
echo "" > $CompErrFile
if g++ *.cpp -Wall -o comp_prog.out >> $CompErrFile 2>&1
then
   echo "Succesfull Compilation" | tee -a $CompErrFile
else
   echo "Unsuccesfull Compilation" | tee -a $CompErrFile
fi

;;
run)
echo "" > $RunErrFile
MAXTIME=$3
MetaFile=MetaFile.log
OutputBuffer=OutBuffer.log
isolate --dir=test_fol=$Test_Dir:rw --chdir=/test_fol --stdin=/test_fol/$Input --box-id=$IDBOX --wall-time=$MAXTIME --mem=50000 --verbose --meta=$MetaFile --run ./comp_prog.out "${@:4:$#-1}" > $OutputBuffer 2>>$RunErrFile
if [ $? -eq 0 ]
then
   cat $OutputBuffer
fi
cat $MetaFile >> $RunErrFile
rm -f $MetaFile

;;
clean)
echo "clean"
#nejaky prikazy tady
;;
remove)
echo "remove"
isolate --box-id=$IDBOX --cleanup
rm -rf $Test_Dir

;;
esac
