from flask_wtf import FlaskForm
from wtforms import StringField, PasswordField, SubmitField, BooleanField, SelectField
from wtforms.validators import DataRequired, Length, Email, EqualTo
from flask_wtf.file import FileField, FileRequired, FileAllowed
from flask_uploads import UploadSet

class RegistrationForm(FlaskForm):
    username = StringField('Username',
                           validators=[DataRequired(), Length(min=2, max=20)])
    email = StringField('Email',
                        validators=[DataRequired(), Email()])
    password = PasswordField('Password', validators=[DataRequired()])
    confirm_password = PasswordField('Confirm Password',
                                     validators=[DataRequired(), EqualTo('password')])
    submit = SubmitField('Sign Up')


class LoginForm(FlaskForm):
    email = StringField('Email',
                        validators=[DataRequired(), Email()])
    password = PasswordField('Password', validators=[DataRequired()])
    remember = BooleanField('Remember Me')
    submit = SubmitField('Login')

class UploadForm(FlaskForm):
    #JmenoTestu = StringField('Jmeno testu', validators=[DataRequired(), Length(min=2, max=20)]) 
    UplJSON = FileField('Nahrajte JSON')
    UplFILE = FileField('Nahrajte test. data')
    ChooseType = SelectField(u'Type Dir choose', choices=[(1, 'Jeden soubor'), (2, 'Jedna slozka'), (3, 'Cela trida'), (4, 'Cela trida - MOODLE EXPORT')])
    submit = SubmitField('TEST')
