#!/usr/bin/python3
import os
#import signal
import json
import subprocess 
import re
from subprocess import PIPE, STDOUT, run, check_output, Popen

def read_json(PathToFile):
  try:
    with open(PathToFile, 'r') as input_file:
      file = json.load(input_file)
      return file
  except Exception as e:
    print("Error during reading JSON: " + str(e))
    return ""

def read_file(PathToFile):
  try:
    with open(PathToFile, 'r') as myfile:
      data = myfile.read()
      return data
  except Exception as e:
    print("Error during reading FILE: " + str(e))
    return ""

def ifNumberOrString(s):  #TRUE-cislo; FALSE-string 
  #float(s)   #co kdyz bude cislo -1.025e-4 co pak???
  #kontrola = re.findall("(?:(?<=\s)|(?<=^))([-+]?[.]?[\d]+(?:,\d\d\d)*[\.]?\d*(?:[eE][-+]?\d+)?)(?=\s|$)", str(s))  #kontrola jestli je v promenne s string nebo nami definovane cislo
  if type(s) is int or type(s) is float:
    return True
  else:
    return False

def BashCommandReturnOutput(command, inputToShell="", timeoutArg=50):  #pokud neni jinak specifikovani, program bude vypnut za 50s
  p = Popen(command, stdin=PIPE, stdout=PIPE, stderr=PIPE, universal_newlines=True)
  try:
    stdout = p.communicate(input=inputToShell, timeout=timeoutArg)[0]
  except Exception as e:
    print("ERROR: " + str(e))
    return "" #vystup test. programu je prazdny string
  else:
    return stdout

def CompilExecCleanRem(CommandWhatToDO=None, ProgrammLang=None, DirectoryToDefaultBashScript=None, DirectoryToWebBashScript=None, UserInput="", UserArgs="", OtherArg1=5, OtherArg2=""): #OtherArg2 = idbox
  #print(CommandWhatToDO)
  WorkingDirectory = str(DirectoryToDefaultBashScript / (ProgrammLang + '.sh'))
  if DirectoryToWebBashScript != "":
    WorkingDirectory = DirectoryToWebBashScript
  if CommandWhatToDO == "init" and OtherArg2 != "":
    BashCommandReturnOutput([WorkingDirectory, "init", OtherArg2])
  elif CommandWhatToDO == "compile":
    if "Succesfull Compilation" in BashCommandReturnOutput([WorkingDirectory, "compile"]):
      return True
    else:
      return False  
  elif CommandWhatToDO == "run" and OtherArg2 != "":   
    f = open("XX_data_prog_input_XX.txt", "w")   #byl zvoleno jmeno souboru kde je pravdepodobny ze ho nikdo zadny zak nepouzije
    f.write(UserInput)
    f.close()
    cache_list = [WorkingDirectory, "run", OtherArg2, str(OtherArg1)]
    if type(UserArgs) is list:
      cache_list += UserArgs  
    return BashCommandReturnOutput(cache_list, "")
  elif CommandWhatToDO == "clean":
    BashCommandReturnOutput([WorkingDirectory, "clean"])
  elif CommandWhatToDO == "remove" and OtherArg2 != "":
    BashCommandReturnOutput([WorkingDirectory, "remove", OtherArg2])

def JsonKey_ifexist(jsonArrayDefault, JsonKey, ValueIfNone=None, jsonArrayLocal=[]):
  def IfStrOrBool(InputString):
    ReturnValue = InputString 
    if type(InputString) is str:
      if InputString.lower() == "true":
        ReturnValue = True
      elif InputString.lower() == "false":
        ReturnValue = False
    return ReturnValue
  Element = ValueIfNone
  if JsonKey in jsonArrayLocal:
    Element = IfStrOrBool(jsonArrayLocal[JsonKey])
  elif JsonKey in jsonArrayDefault:
    Element = IfStrOrBool(jsonArrayDefault[JsonKey])
  return Element

def MakeArrayOfNumFromOutput(JsonOutput, ProgOutput): 
  NumberArray = []   #pole nalezenych cisel z programu testovaneho (float)
  JsonStringArray = []   #pole nalezenych stringu z programu testovaneho (float)
  JsonNumberArray = []  #upravene json pole kde jsou jen cisla z nej (float)
  for i in JsonOutput:
    if ifNumberOrString(i):
      JsonNumberArray.append(i)
      if not NumberArray: 
        NumberArray = re.findall("(?:(?<=\s)|(?<=^))([-+]?[.]?[\d]+(?:,\d\d\d)*[\.]?\d*(?:[eE][-+]?\d+)?)(?=\s|$)", ProgOutput) #vyplivne vsechna cisla z pusteneho programu
        if NumberArray: 
          NumberArray = list(map(float, NumberArray)) 
    else:
      JsonStringArray.append(i)
  JsonNumberArray = list(map(float, JsonNumberArray)) 
  return NumberArray, JsonStringArray, JsonNumberArray

def tolerance_check(JsNumArrayOrValue, NumberArrayOrValueFromOut, JsTolerance, PositionJS=0, PositionOUT=0):
  ReturnValue = False
  FinalTolerance = 0
  if type(JsTolerance) is list: #and (len(JsNumArrayOrValue) == len(JsTolerance)):
    if PositionJS < len(JsTolerance):
      FinalTolerance = JsTolerance[PositionJS]
  elif (type(JsTolerance) is int) or (type(JsTolerance) is float):
    FinalTolerance = JsTolerance
  if (type(JsNumArrayOrValue) is list) and (type(NumberArrayOrValueFromOut) is list):
    #(len(JsNumArrayOrValue) <= len(NumberArrayOrValueFromOut)) and
    if (PositionJS < len(JsNumArrayOrValue)) and (PositionOUT < len(NumberArrayOrValueFromOut)):
      if ((NumberArrayOrValueFromOut[PositionOUT] + FinalTolerance) >= JsNumArrayOrValue[PositionJS]) and ((NumberArrayOrValueFromOut[PositionOUT] - FinalTolerance) <= JsNumArrayOrValue[PositionJS]):
        ReturnValue = True
  else:
    if ((NumberArrayOrValueFromOut + FinalTolerance) >= JsNumArrayOrValue) and ((NumberArrayOrValueFromOut - FinalTolerance) <= JsNumArrayOrValue):
      ReturnValue = True
  return ReturnValue

def FindStringInString(search, string):
  #if string.find(str(search)) != -1:	#hleda v $output retez z "out" z JSONu   50=nasel -1=nenasel 
  #if search in str(string):
  #searchWithFilter = "(?:(?<=\s)|(?<=^))(" + search + ")(?=\s|$)" #najde hledany string s mezerou okolo sebe nebo zacatkem/koncem radku vedle sebe
  #vystup = re.findall(searchWithFilter, str(string))
  if search in string:
    return 1         #1 - uspesne hledani, 'string' - vrati string nahrazeny <???> misto najiteho slova
  else: 
    return 0

def FindResultFromArrays(JsonNumberArray, JsonStringArray, NumberArrayFromPrgOutputParam, AllPrgOutput, UpperLower, TolerFromJSON, GraduallyOrRandomFinding):  #hledani shody cisel JSON vs OUTPUT
  succesJson = 0
  succesFinal = 0
  succesJson = len(JsonNumberArray) + len(JsonStringArray)
  wrong_elements = []
  NumberArrayFromPrgOutput = NumberArrayFromPrgOutputParam.copy()
  if GraduallyOrRandomFinding:      #postupne hledani nebo nahodile 
    NumberEditedOutput = AllPrgOutput    
    for x in range(0,len(JsonNumberArray)):        
      if tolerance_check(JsonNumberArray, NumberArrayFromPrgOutput, TolerFromJSON, x, x):
        succesFinal += 1
        NumberEditedOutput = NumberEditedOutput.replace(str(NumberArrayFromPrgOutput[x]), str(JsonNumberArray[x]),2)
      else:
        wrong_elements.append(JsonNumberArray[x])
  else:
    poleSpravnychCisel = []
    for x in range(0,len(JsonNumberArray)):
      for y in range(0,len(NumberArrayFromPrgOutput)):
        if tolerance_check(JsonNumberArray, NumberArrayFromPrgOutput, TolerFromJSON, x, y):
          NumberArrayFromPrgOutput.remove(NumberArrayFromPrgOutput[y])
          poleSpravnychCisel.append(JsonNumberArray[x])
          succesFinal += 1
          break

    set1 = set(JsonNumberArray)
    set2 = set(poleSpravnychCisel)
    set_diff = set1.difference(set2)
    subtracted_list = list(set_diff)
    wrong_elements += subtracted_list
    
  for x in JsonStringArray:
    if FindStringInString(x, AllPrgOutput) == 1:
      succesFinal += 1
    else:
      wrong_elements.append(x)
    AllPrgOutput = AllPrgOutput.replace(str(x), "<???>", 1)   #vymaze string ktery jsme hledali, aby se nam tam nepletl. Je nahrazen <???>

  return wrong_elements, succesJson - succesFinal
  #return ("Uspesnost programu: " + str((succesFinal/succesJson)*100) + " %")  #TOHLE JE DOCASNE RESENI!!!!!!!!!

def LowerArrayOrString(Param):
  if type(Param) is list:
    for i in range(0, len(Param)):
      if type(Param[i]) is str:
        Param[i] = Param[i].lower()      
    return Param
  elif type(Param) is str:
    return Param.lower()
  else:
    return -1

def StaticTextFunc(StaticTextJsonArray, OutJsonArray, JsonUpperLower, JsonToleranceArray, OutputText):

  def DistanceBetweenStrings(HlavniList, PevneDanaSlovaList, VkladaneElementyList):
      PolePozic = []
      for y in range(0,len(PevneDanaSlovaList)):
          PoziceSlova = HlavniList.index(PevneDanaSlovaList[y])
          PoziceSlovaArray = []
          PoziceSlovaArray.append(PevneDanaSlovaList[y])
          for i in range(0, len(VkladaneElementyList)):
              PoziceVkladaneho = HlavniList.index(VkladaneElementyList[i])
              VzdalenostPrvku = PoziceVkladaneho - PoziceSlova
              Element = VkladaneElementyList[i].translate({ord(i): None for i in '{}'})
              Element = int(Element)
              PoleHodnot = [VzdalenostPrvku, Element]
              PoziceSlovaArray.append(PoleHodnot)
          PolePozic.append(PoziceSlovaArray)
      return PolePozic

  def NalezeniSchodyZachytSlovaRekurze(PoleZFunkce, Text, JsonAr, JsToleranceArray, PredpoklPoziceVklaArrayElement=[], PoziceVPoli=0):
      FinalReturn = False
      c = PoleZFunkce[PoziceVPoli]
      MistaVyskytu = [i for i, x in enumerate(Text) if x == c[0]]
      for a in MistaVyskytu:
          pocetBodu = len(c)-1
          shoda = 0
          PolePoziceElementu = []
          for b in range(1, len(c)):
            pozice = a + c[b][0]
            if pozice < len(Text):
              Text1 = JsonAr[c[b][1]]
              Text2 = Text[pozice]
              if ifNumberOrString(Text1) is True:
                try:
                  Text2 = float(Text2)
                except ValueError:
                  pass
                if ifNumberOrString(Text2) is True:
                  PoziceToler = c[b][1]-1
                  if PoziceToler < 0:
                    PoziceToler = 0
                  if tolerance_check(Text1, Text2, JsonToleranceArray, PoziceToler) is True:
                    shoda += 1
                    PolePoziceElementu.append(pozice)
              else:
                if Text2 == str(Text1):
                  shoda += 1
                  PolePoziceElementu.append(pozice)
          PolePoziceElementu.sort()
          PredpoklPoziceVklaArrayElement.sort()
          if pocetBodu == shoda:
              if(PoziceVPoli+1 < len(PoleZFunkce)) and ((PredpoklPoziceVklaArrayElement == PolePoziceElementu) or (PredpoklPoziceVklaArrayElement == [])):
                  FinalReturn = NalezeniSchodyZachytSlovaRekurze(PoleZFunkce, Text, JsonAr, JsToleranceArray, PolePoziceElementu, PoziceVPoli+1)
              elif(PoziceVPoli+1 >= len(PoleZFunkce)):
                  if(PredpoklPoziceVklaArrayElement == PolePoziceElementu) or (PredpoklPoziceVklaArrayElement == []):
                      FinalReturn = True 
                      #print(str(PolePoziceElementu) + " == " + str(PredpoklPoziceVklaArrayElement))
      return FinalReturn

  OutputText = OutputText.split()
  count_of_mistakes = 0
  data_collector = []  #vysledny zaznam o statickych textech
  for part in StaticTextJsonArray:
    buffer = {}
    VkladajicichElementu = re.findall('(?:(?<=\s)|(?<=^))({\d*})(?=\s|$)', part)
    VkladajicichElementu.sort()
    RozdelenyStaticText = part.split()
    ZachytnaSlova = RozdelenyStaticText.copy()
    [ZachytnaSlova.remove(x) for x in VkladajicichElementu]
    mericVzalenosti = DistanceBetweenStrings(RozdelenyStaticText, ZachytnaSlova, VkladajicichElementu)
    
    if NalezeniSchodyZachytSlovaRekurze(mericVzalenosti, OutputText, OutJsonArray, JsonToleranceArray) is True:
      buffer['status'] = "successful"
    else:
      buffer['status'] = "unsuccessful"
      count_of_mistakes += 1
    buffer['searched_text'] = str(part)
    data_collector.append(buffer)
    #print("Staticky text: " + "[" + str(part) + "]")
    #print("Vysledek: " + str(NalezeniSchodyZachytSlovaRekurze(mericVzalenosti, OutputText, OutJsonArray, JsonToleranceArray)))
  return data_collector, count_of_mistakes
        