#!/bin/bash
# Job =>
# -init -- do commands before execution and compilation
# ./java.sh init <idbox>
# -compile -- do all necessary operation for succesfull compilation
# ./java.sh compile
# -run -- will run tested program 
# ./java.sh run <idbox> <timeout> "userArg1 userArg2"
# -clean -- do command to clear some txt files or whatever else
# ./java.sh clean
# -remove <idbox> -- will remove compiled program and created txt´s
# ./java.sh remove <idbox>

Job=$1
IDBOX=$2
CompErrFile=CompErr.log
RunErrFile=RunErr.log
MetaFile=MetaFile.log
OutputBuffer=OutBuffer.log
Input=XX_data_prog_input_XX.txt
Piskot_Dir="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
Test_Dir=$(pwd)

JAVA_classes=xx_java_class_xx

case $Job in
init)
isolate --box-id=$IDBOX --cleanup 
isolate --box-id=$IDBOX --init


;;
compile)
echo "" > $CompErrFile
find -name "*.java" > xx_sources_xx.txt
mkdir -p $JAVA_classes
if javac @xx_sources_xx.txt -d $JAVA_classes >> $CompErrFile 2>> $CompErrFile
then
   echo "Succesfull Compilation" | tee -a $CompErrFile
else
   echo "Unsuccesfull Compilation" | tee -a $CompErrFile
fi

;;
run)
echo "" > $RunErrFile
MAXTIME=$3
MetaFile=MetaFile.log
OutputBuffer=OutBuffer.log
JAVA_path=$(readlink -f $(which java))
JAVA_main=$(cd $JAVA_classes; find * -iname "main.class" -print -quit | sed s/.class//)
if [ -n "$JAVA_main" ] && [ -d $JAVA_classes ]; then
   isolate --dir=test_fol="$Test_Dir":rw --chdir="/test_fol/$JAVA_classes" --stdin="/test_fol/$Input" --box-id=$IDBOX --verbose --meta=$MetaFile --run --processes "$JAVA_path" "$JAVA_main" "${@:4:$#-1}" > $OutputBuffer 2>>$RunErrFile
   #returnCode=$?
   #if [ $returnCode -eq 0 ]
   #then
   cat $OutputBuffer
   #fi
   cat $MetaFile >> $RunErrFile
   rm -f $MetaFile
else
   echo "Nebyl nalezen soubor Main.class" >> $RunErrFile
fi

;;
clean)
echo "clean"

;;
remove)
echo "remove"
isolate --box-id=$IDBOX --cleanup
rm -rf "$Test_Dir"

;;
esac