#!/usr/bin/python3 
import sys
import os
import function #my own file
import json
from pathlib import Path


#argv[1] -- JSON; argv[2] -- TESTED_DIRECTORY
#RunPiskotTest(sys.argv[1], sys.argv[2])

def RunPiskotTest(JSON_Path="", TEST_Dir_Path="", MODIFIED_BashScript_Path=""):

  FINAL_JSON_DATA = {}
  FINAL_JSON_DATA['final_succ_rate'] = 0
  FINAL_JSON_DATA['final_checked_elements'] = 0
  FINAL_JSON_DATA['final_count_mistakes'] = 0
  FINAL_JSON_DATA['compilation_err'] = ""
  FINAL_JSON_DATA['other_err'] = ""
  FINAL_JSON_DATA['tests'] = []

  #vychozi stav globalnich promennych
  directory_def = Path(__file__).parent.absolute()   #cesta ke slozce kde je ulozen tento zdrojak, ve slozce musi byt i bash scripty
  test_lang_def = "c"  #defaultni prog. jazyk je C
  tolerance_def = 0
  postupneHodnoceni_def = False
  velkaMala_def = False
  statTXT_def = ""
  input_argum_def = ""
  vstup_data_def = ""
  clean_def = False
  timeout_def = 5

  directory_testedDir = TEST_Dir_Path   #cesta k testovaci slozce
  print(directory_testedDir)
  FINAL_JSON_DATA['folder_name'] = os.path.basename(directory_testedDir)  #ulozi do jmeno slozky do dictu
  if Path.is_dir(Path(directory_testedDir)) is True:
    json_file = function.read_json(JSON_Path) #nacte cely JSON z argumentu 1 jako dat. typ dict CO KDYZ FILE NEPUDE PRECIST??   Vyuzva sys.argv[1]
    if json_file != "":
      test_lang = function.JsonKey_ifexist(json_file, "jazyk", test_lang_def)
      tolerance = function.JsonKey_ifexist(json_file, "toler", tolerance_def)
      postupneHodnoceni = function.JsonKey_ifexist(json_file, "postupneHodnoceni", postupneHodnoceni_def)
      velkaMala = function.JsonKey_ifexist(json_file, "velka_mala", velkaMala_def)
      statTXT = function.JsonKey_ifexist(json_file, "stat_txt", statTXT_def)
      input_argum = function.JsonKey_ifexist(json_file, "input_args", input_argum_def)
      clean = function.JsonKey_ifexist(json_file, "clean", clean_def)
      timeout = function.JsonKey_ifexist(json_file, "timeout", timeout_def)

      #os.chdir(function.BashCommandReturnOutput([str(directory_def / "make_tmp.sh"), directory_testedDir], timeoutArg=120))  #dostane se do slozky
      os.chdir(directory_testedDir)
      #pocet_scen = len(json_file["data"])-1
      VystupIdManageru = function.BashCommandReturnOutput([str(directory_def / "get_idbox.sh")], timeoutArg=120)  #zadost o PRIDELENI ID k boxu
      if VystupIdManageru == "":
        print("Nebyl pridelen testovaci box!")
      else:
        VystupIdManageru=str(VystupIdManageru)  #prevedeni idboxu (cisla) na string abysme ho mohli pouzit ve funkci 'BashCommandReturn'
        function.CompilExecCleanRem("init", test_lang, directory_def, MODIFIED_BashScript_Path, OtherArg2=VystupIdManageru)   #do parametru "" se da cesta ke specialnimu bashi udelanemu z webu 
        if function.CompilExecCleanRem("compile", test_lang, directory_def, MODIFIED_BashScript_Path) is True:

          FINAL_JSON_DATA['compilation_err'] = function.read_file("CompErr.log")
          count_of_tests_sceneries = 0
          for p in json_file["data"]:	#tolikrat kolikrat je v JS. testovacich scenaru

            test_data_collector = {} #vytvoreni slovniku kam se pisou jednotlive testy, po dodelani bude pridan k hlavnimu vyslednemu jsonu FINAL_JSON_DATA do tests
            test_data_collector['test_number'] = count_of_tests_sceneries
            input_argum = function.JsonKey_ifexist(json_file, "input_args", input_argum_def, p)
            clean = function.JsonKey_ifexist(json_file, "clean", clean_def, p)
            timeout = function.JsonKey_ifexist(json_file, "timeout", timeout_def, p)
            if clean is True:
              function.CompilExecCleanRem("clean", test_lang, directory_def, MODIFIED_BashScript_Path) #procisti slozku pred testovanim programu
            output = ""
            
            for t in p["input_output"]:
              io = function.JsonKey_ifexist(t, "io", "console")
              vstup_data = '\n'.join(str(x) for x in function.JsonKey_ifexist(t, "in", vstup_data_def))	#mezi prvky z "in" z JSONu vlozi '\n'
              if io == "console": 
                output = function.CompilExecCleanRem("run", test_lang, directory_def, MODIFIED_BashScript_Path, vstup_data, input_argum, timeout, VystupIdManageru) #pusteni testovaciho programu
              else:
                f = open(io, "w")
                f.write(vstup_data)
                f.close()

            if output == "" :
              test_data_collector['prog_stat_on_end'] = "unsuccessful"  #zapis jestli bylo pusteni programu uspesne
            else:
              test_data_collector['prog_stat_on_end'] = "successful"
            test_data_collector['running_err'] = function.read_file("RunErr.log")   #zapis jak bezel program (log) (vystup z isolate)
            test_data_collector['tests_succ_rate'] = 0
            test_data_collector['tests_count_checked_elements'] = 0
            test_data_collector['tests_count_mistakes'] = 0
            test_data_collector['parts_of_tests'] = []
            
            for q in p["input_output"]: 
              parts_of_tests_buffer = {} #docasne uloziste

              io = function.JsonKey_ifexist(q, "io", "console") #kdyz v JSONu nebude "io" specifikovano, bude myslen vystup z console
              if io != "console":
                output = function.read_file(io)
              parts_of_tests_buffer['IO'] = io
              parts_of_tests_buffer['IO_output'] = output

              vystup_data = function.JsonKey_ifexist(q, "out", "")    #JSON 'console'

              parts_of_tests_buffer['json_in_elements'] = function.JsonKey_ifexist(q, "in", vstup_data_def)
              parts_of_tests_buffer['json_out_elements'] = vystup_data

              tolerance = function.JsonKey_ifexist(json_file, "toler", tolerance_def, q) 
              postupneHodnoceni = function.JsonKey_ifexist(json_file, "postupneHodnoceni", postupneHodnoceni_def, q)
              velkaMala = function.JsonKey_ifexist(json_file, "velka_mala", velkaMala_def, q)
              statTXT = function.JsonKey_ifexist(json_file, "stat_txt", statTXT_def, q)

              parts_of_tests_buffer['count_checked_elements'] = len(vystup_data) + len(statTXT)  #pocet kontrolujicich elementu je pocet "out" a pocet prvku v "stat_txt"

              if velkaMala is False:
                statTXT = function.LowerArrayOrString(statTXT)
                vystup_data = function.LowerArrayOrString(vystup_data)
                output = function.LowerArrayOrString(output)
              NumberMatch, StringJSON, NumberJSON = function.MakeArrayOfNumFromOutput(vystup_data, output)

              parts_of_tests_buffer['failed_elements'], pocet_spatnych_elem = function.FindResultFromArrays(NumberJSON, StringJSON, NumberMatch, output, velkaMala, tolerance, postupneHodnoceni)
              parts_of_tests_buffer['static_text'], pocet_spatnych_stat = function.StaticTextFunc(statTXT, vystup_data, velkaMala, tolerance, output)
              parts_of_tests_buffer['count_mistakes'] = pocet_spatnych_elem + pocet_spatnych_stat  #pocet chyb v cislech/stringu + pocet chyb v testovani statickym textem
              parts_of_tests_buffer['succ_rate'] = float("{0:.2f}".format(((parts_of_tests_buffer['count_checked_elements'] - parts_of_tests_buffer['count_mistakes'])/(parts_of_tests_buffer['count_checked_elements']))*100))
              
              test_data_collector['tests_count_checked_elements'] += parts_of_tests_buffer['count_checked_elements']
              test_data_collector['tests_count_mistakes'] += parts_of_tests_buffer['count_mistakes']
              test_data_collector['tests_succ_rate'] = float("{0:.2f}".format((test_data_collector['tests_count_checked_elements'] - test_data_collector['tests_count_mistakes'])/test_data_collector['tests_count_checked_elements'] * 100))
              test_data_collector['parts_of_tests'].append(parts_of_tests_buffer)
              
            FINAL_JSON_DATA['final_checked_elements'] += test_data_collector['tests_count_checked_elements']
            FINAL_JSON_DATA['final_count_mistakes'] += test_data_collector['tests_count_mistakes']
            FINAL_JSON_DATA['final_succ_rate'] = float("{0:.2f}".format((FINAL_JSON_DATA['final_checked_elements'] - FINAL_JSON_DATA['final_count_mistakes'])/FINAL_JSON_DATA['final_checked_elements'] * 100))
            FINAL_JSON_DATA['tests'].append(test_data_collector)

            count_of_tests_sceneries += 1 #kvuli zapisu do vysledneho jaky test se zrovna dela
            #print("IO_device:" + str(io))
            #print("vystupIO:\n" + output)
            #print("PostupneHodJSON: " + str(postupneHodnoceni) + "|| TolerJSON: " + str(tolerance) + "|| VelkMAL: " + str(velkaMala) + "|| CleanJS: " + str(clean))
            #print("InputARGS_JSON: " + str(input_argum))
            #print("vystupFUNC_CISL: " + str(NumberMatch))
            #print("vystupJSON_CISL: " + str(NumberJSON))
            #print("vystupJSON_STR: " + str(StringJSON))
            #print("Puvodni JSON: " + str(vystup_data))
            #print(zaver)
            #print("----------------------------------------------------------")
              
            #print("\n----\noutput: \n" + output.decode() + "\nZ JSONu: " + str(vystup_data) + "\ntolerance " + str(tolerance) + "\n-----")
              #["OBdelniK", 24, 3.045, 7.1]'''
            
          function.CompilExecCleanRem("remove", test_lang, directory_def, MODIFIED_BashScript_Path, OtherArg2=VystupIdManageru)   #do parametru "" se da cesta ke specialnimu bashi udelanemu z webu 
        else:
          FINAL_JSON_DATA['compilation_err'] = function.read_file("CompErr.log")
        function.BashCommandReturnOutput([str(directory_def / ('idbox_man.sh')), "remove", VystupIdManageru], timeoutArg=120)  #zadost o smazani ID k boxu
      os.chdir(directory_def)  #vratime se zpet do slozky kde je ulozen piskot.py
    else:
      FINAL_JSON_DATA['other_err'] = "Json file nelze precist"
  else:
    FINAL_JSON_DATA['other_err'] = "Cesta k testovaci slozce neni mozna"

  with open("data_file.json", "w") as write_file:
    json.dump(FINAL_JSON_DATA, write_file)
  return FINAL_JSON_DATA
  #y = json.dumps(FINAL_JSON_DATA)
  #return y


#IDBOX = function.BashCommandReturnOutput([str(directory_def / "idbox_man.sh"), "get"], timeoutArg=120)  #zadost o PRIDELENI ID k boxu
#function.BashCommandReturnOutput([str(directory_def / ('idbox_man.sh')), "remove", VystupIdManageru], timeoutArg=120)  #zadost o SMAZANI ID k boxu    
